Column with Group Label in JavaScript

Using ApexCharts with JavaScript

This Column with Group Label example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// quarter label from a 'YYYY/MM/DD' date string, no external date library
function quarterOf(val) {
  return Math.floor(new Date(val).getMonth() / 3) + 1
}

var options = {
  series: [
    {
      name: 'Revenue',
      data: [
        {
          x: '2024/01/01',
          y: 400,
        },
        {
          x: '2024/04/01',
          y: 430,
        },
        {
          x: '2024/07/01',
          y: 448,
        },
        {
          x: '2024/10/01',
          y: 470,
        },
        {
          x: '2025/01/01',
          y: 540,
        },
        {
          x: '2025/04/01',
          y: 580,
        },
        {
          x: '2025/07/01',
          y: 690,
        },
        {
          x: '2025/10/01',
          y: 690,
        },
      ],
    },
  ],
  chart: {
    type: 'bar',
    height: 380,
  },
  xaxis: {
    type: 'category',
    labels: {
      formatter: function (val) {
        return 'Q' + quarterOf(val)
      },
    },
    group: {
      style: {
        fontSize: '10px',
        fontWeight: 700,
      },
      groups: [
        { title: '2024', cols: 4 },
        { title: '2025', cols: 4 },
      ],
    },
  },
  title: {
    text: 'Quarterly Revenue',
  },
  yaxis: {
    labels: {
      formatter: function (val) {
        return '$' + val + 'k'
      },
    },
  },
  tooltip: {
    x: {
      formatter: function (val) {
        return 'Q' + quarterOf(val) + ' ' + new Date(val).getFullYear()
      },
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Column with Group Label in Vue

Using ApexCharts with Vue

This Column with Group Label example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="bar"
        height="380"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

// quarter label from a 'YYYY/MM/DD' date string, no external date library
function quarterOf(val) {
  return Math.floor(new Date(val).getMonth() / 3) + 1
}

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'Revenue',
          data: [
            {
              x: '2024/01/01',
              y: 400,
            },
            {
              x: '2024/04/01',
              y: 430,
            },
            {
              x: '2024/07/01',
              y: 448,
            },
            {
              x: '2024/10/01',
              y: 470,
            },
            {
              x: '2025/01/01',
              y: 540,
            },
            {
              x: '2025/04/01',
              y: 580,
            },
            {
              x: '2025/07/01',
              y: 690,
            },
            {
              x: '2025/10/01',
              y: 690,
            },
          ],
        },
      ],
      chartOptions: {
        chart: {
          type: 'bar',
          height: 380,
        },
        xaxis: {
          type: 'category',
          labels: {
            formatter: function (val) {
              return 'Q' + quarterOf(val)
            },
          },
          group: {
            style: {
              fontSize: '10px',
              fontWeight: 700,
            },
            groups: [
              { title: '2024', cols: 4 },
              { title: '2025', cols: 4 },
            ],
          },
        },
        title: {
          text: 'Quarterly Revenue',
        },
        yaxis: {
          labels: {
            formatter: function (val) {
              return '$' + val + 'k'
            },
          },
        },
        tooltip: {
          x: {
            formatter: function (val) {
              return 'Q' + quarterOf(val) + ' ' + new Date(val).getFullYear()
            },
          },
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
</style>

Column with Group Label in React

Using ApexCharts with React

This Column with Group Label example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

// quarter label from a 'YYYY/MM/DD' date string, no external date library
function quarterOf(val) {
  return Math.floor(new Date(val).getMonth() / 3) + 1
}

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Revenue',
        data: [
          {
            x: '2024/01/01',
            y: 400,
          },
          {
            x: '2024/04/01',
            y: 430,
          },
          {
            x: '2024/07/01',
            y: 448,
          },
          {
            x: '2024/10/01',
            y: 470,
          },
          {
            x: '2025/01/01',
            y: 540,
          },
          {
            x: '2025/04/01',
            y: 580,
          },
          {
            x: '2025/07/01',
            y: 690,
          },
          {
            x: '2025/10/01',
            y: 690,
          },
        ],
      },
    ],
    options: {
      chart: {
        type: 'bar',
        height: 380,
      },
      xaxis: {
        type: 'category',
        labels: {
          formatter: function (val) {
            return 'Q' + quarterOf(val)
          },
        },
        group: {
          style: {
            fontSize: '10px',
            fontWeight: 700,
          },
          groups: [
            { title: '2024', cols: 4 },
            { title: '2025', cols: 4 },
          ],
        },
      },
      title: {
        text: 'Quarterly Revenue',
      },
      yaxis: {
        labels: {
          formatter: function (val) {
            return '$' + val + 'k'
          },
        },
      },
      tooltip: {
        x: {
          formatter: function (val) {
            return 'Q' + quarterOf(val) + ' ' + new Date(val).getFullYear()
          },
        },
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="bar"
          height={380}
        />
      </div>
    </div>
  )
}

export default ApexChart

Column with Group Label in Angular

Using ApexCharts with Angular

This Column with Group Label example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private quarterOf = (val: any): any => {
          return Math.floor(new Date(val).getMonth() / 3) + 1
        };

  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Revenue',
              data: [
                {
                  x: '2024/01/01',
                  y: 400,
                },
                {
                  x: '2024/04/01',
                  y: 430,
                },
                {
                  x: '2024/07/01',
                  y: 448,
                },
                {
                  x: '2024/10/01',
                  y: 470,
                },
                {
                  x: '2025/01/01',
                  y: 540,
                },
                {
                  x: '2025/04/01',
                  y: 580,
                },
                {
                  x: '2025/07/01',
                  y: 690,
                },
                {
                  x: '2025/10/01',
                  y: 690,
                },
              ],
            },
          ],
          chart: {
            type: 'bar',
            height: 380,
          },
          xaxis: {
            type: 'category',
            labels: {
              formatter: (val) => {
                return 'Q' + this.quarterOf(val)
              },
            },
            group: {
              style: {
                fontSize: '10px',
                fontWeight: 700,
              },
              groups: [
                { title: '2024', cols: 4 },
                { title: '2025', cols: 4 },
              ],
            },
          },
          title: {
            text: 'Quarterly Revenue',
          },
          yaxis: {
            labels: {
              formatter: (val) => {
                return '$' + val + 'k'
              },
            },
          },
          tooltip: {
            x: {
              formatter: (val) => {
                return 'Q' + this.quarterOf(val) + ' ' + new Date(val).getFullYear()
              },
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}